(use-modules (oop goops) (mod1) (mod2))

(define (!= foo b) (not (= foo b)))

(define (testFoo foo initval)
  (if (!= (Foo-a-get foo) initval)  (display "Test 1 failed") )
  (Foo-a-set foo (+ initval 1))
  (if (!= (Foo-a-get foo) (+ initval 1))  (display "Test 2 failed") )
  (set! (Foo-a foo) (+ initval 2))
  (if (!= (Foo-a foo) (+ initval 2))  (display "Test 3 failed") ))

(define (testGoopsFoo foo initval)
  (if (!= (goops:a foo) initval)  (display "Test 4 failed") )
  (set! (goops:a foo) (+ initval 1))
  (if (!= (goops:a foo) (+ initval 1))  (display "Test 5 failed") ))

(define (testBar bar initval fooinitval)
  (if (!= (Bar-getInt bar) initval)  (display "Test 6 failed") )
  (testFoo (Bar-getFoo bar) fooinitval))

(define (testGoopsBar bar initval fooinitval)
  (if (!= (goops:getInt bar) initval)  (display "Test 8 failed") )
  (testGoopsFoo (goops:getFoo bar) fooinitval))

(define (testOops oops initval)
  (if (!= (Oops-c-b-get oops) initval)  (display "Test 10 failed") )
  (Oops-c-c-set oops 4)
  (if (!= (Oops-c-c-get oops) 4)  (display "Test 11 failed") )
  (if (!= (Oops-c-b oops) initval)  (display "Test 12 failed") )
  (set! (Oops-c-c oops) 5)
  (if (!= (Oops-c-c oops) 5)  (display "Test 13 failed") ))

(define (testGoopsOops oops initval)
  (if (!= (goops:b oops) initval)  (display "Test 14 failed") )
  (set! (goops:c oops) 4)
  (if (!= (goops:c oops) 4)  (display "Test 15 failed") ))

(define (testJoo joo initval)
  (if (!= (Joo-getInt joo) initval)  (display "Test 16 failed") )
  (Joo-mult-by joo 2)
  (if (!= (getJooInt joo) (* initval 2))  (display "Test 17 failed") )
  (testBar joo (* initval 2) (* initval 10))
  (testBar (JooToBar joo 2) (* initval 4) (* initval 10))
  (testOops joo (* initval 100)))

(define (testGoopsJoo joo initval)
  (if (!= (goops:getInt joo) initval)  (display "Test 18 failed") )
  (goops:mult-by joo 2)
  (if (!= (goops:getJooInt joo) (* initval 2))  (display "Test 19 failed") )
  (testGoopsBar joo (* initval 2) (* initval 10))
  (testGoopsBar (goops:JooToBar joo 2) (* initval 4) (* initval 10))
  (testGoopsOops joo (* initval 100)))

(define (testOther other initval)
  (if (!= (OtherModule-get other) initval) (display "Test 20 failed"))
  (if (!= (getIntFunction other) (* initval 2)) (display "Test 21 failed"))
  (testFoo (OtherModule-goodbye-get other) (* initval 100))
  (testFoo (OtherModule-goodbye other) (+ (* initval 100) 2))
  (testFoo (OtherModule-good other) (+ (* initval 100) 4))
  (testJoo other (* initval 2))
  (OtherModule-goodbye-set other (new-Goodbye 6))
  (testFoo (OtherModule-goodbye other) 6)
  (set! (OtherModule-goodbye other) (new-Goodbye 8))
  (testFoo (OtherModule-goodbye-get other) 8)
  (testFoo (getHelloo other 24) 24))

(define (testGoopsOther other initval)
  (if (!= (goops:get other) initval) (display "Test 21 failed"))
  (if (!= (goops:getIntFunction other) (* initval 2)) (display "Test 22 failed"))
  (testGoopsFoo (goops:goodbye other) (* initval 100))
  (testGoopsFoo (goops:good other) (+ (* initval 100) 1))
  (testGoopsJoo other (* initval 2))
  (set! (goops:goodbye other) (make <Goodbye> #:args '(6)))
  (testGoopsFoo (slot-ref other 'goops:goodbye) 6)
  (testGoopsFoo (goops:getHelloo other 27) 27))

(testFoo (new-Foo 10) 10)
(testGoopsFoo (make <Foo> #:args '(10)) 10)
(testBar (new-Bar 15) 15 15)
(testGoopsBar (make <Bar> #:args '(16)) 16 16)
(testFoo (new-Goodbye 10) 10)
(testGoopsFoo (make <Goodbye> #:args '(10)) 10)
(testOops (new-Oops-c 3) 3)
(testGoopsOops (make <Oops-c> #:args '(6)) 6)
(testJoo (new-Joo 6) 6)
(testGoopsJoo (make <Joo> #:args '(8)) 8)
(testJoo (new-Joo) 13)
(testGoopsJoo (make <Joo>) 13)
(testOther (new-OtherModule 7) 7)
(testGoopsOther (make <OtherModule> #:args '(7)) 7)

(testJoo (globalJoo) 13)
(testGoopsJoo (goops:globalJoo) 13)
(globalJoo (new-Joo 18))
(testJoo (globalJoo) 18)
(set! (goops:globalJoo) (make <Joo> #:args '(4)))
(testGoopsJoo (goops:globalJoo) 4)
